/** @file HL_sys_main.c 
*   @brief Application main file
*   @date 11-Dec-2018
*   @version 04.07.01
*
*   This file contains an empty main function,
*   which can be used for the application.
*/

/* 
* Copyright (C) 2009-2018 Texas Instruments Incorporated - www.ti.com  
* 
* 
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions 
*  are met:
*
*    Redistributions of source code must retain the above copyright 
*    notice, this list of conditions and the following disclaimer.
*
*    Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the 
*    documentation and/or other materials provided with the   
*    distribution.
*
*    Neither the name of Texas Instruments Incorporated nor the names of
*    its contributors may be used to endorse or promote products derived
*    from this software without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
*  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
*  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/


/* USER CODE BEGIN (0) */
#include "HL_het.h"
/* USER CODE END */

/* Include Files */

#include "HL_sys_common.h"

/* USER CODE BEGIN (1) */
bool result1;
bool result2;
/* USER CODE END */

/** @fn void main(void)
*   @brief Application main function
*   @note This function is empty by default.
*
*   This function is called after startup.
*   The user can use this function to implement the application.
*/

/* USER CODE BEGIN (2) */
#define ENANLE 0xA
#define DISABLE 0x5
#define LBPTSTENA_BIT_POS   16
/* USER CODE END */

int main(void)
{
/* USER CODE BEGIN (3) */
    hetInit();
    hetREG1->LBPDIR = ENANLE << LBPTSTENA_BIT_POS; //Enable Loopback for HET1
    hetREG1->LBPSEL &= ~(1 << 16); //Selecting Digital loopback
    //hetREG1->LBPSEL |= (1 << 16); //Selecting Analog loopback
    //hetREG1->LBPDIR &= ~(1 << 0); // HET1[1] as output and HET1[0] as input
    hetREG1->LBPSEL |= 1 << 0;  // Selecting Pair HET1[0] and HET1[1]
    hetREG1->LBPDIR |= (1 << 0); // HET1[0] as output and HET1[1] as input

    hetREG2->LBPDIR = ENANLE << LBPTSTENA_BIT_POS; //Enable Loopback HET2
    //hetREG2->LBPSEL &= ~(1 << 16); //Selecting Digital loopback
    hetREG1->LBPSEL |= (1 << 16); //Selecting Analog loopback
    hetREG2->LBPSEL |= 1 << 2;  // Selecting Pair HET2[4] and HET2[5]
    hetREG2->LBPDIR |= (1 << 2); // HET2[4] as output and HET2[5] as input

    hetREG1->DOUT |= 1 << 0;    //Writing 1 to HET1[0]
    while((hetREG1->DOUT & (1 << 0)) != (1 << 0));

    if(hetREG1->DIN & 1 << 1) //Reading to HET1[1] and comparing with 1
    {
        hetREG1->DOUT &= ~(1 << 0); //Writing 0 to HET1[0]
        while((hetREG1->DOUT & (1 << 0)) != 0);
        if((hetREG1->DIN & 1 << 1) == 0) //Reading to HET1[0] and comparing with 0
        {
            result1 = true;
        }
        else
        {
            result1 = false;
        }
    }
    else
    {
        result1 = false;
    }


    hetREG2->DOUT |= 1 << 4;    //Writing 1 to HET1[0]
    while((hetREG2->DOUT & (1 << 4)) != (1 << 4));

    if(hetREG2->DIN & 1 << 5) //Reading to HET2[5] and comparing with 1
    {
        hetREG2->DOUT &= ~(1 << 4); //Writing 0 to HET2[4]
        while((hetREG2->DOUT & (1 << 4)) != 0);
        if((hetREG2->DIN & 1 << 5) == 0) //Reading to HET2[5] and comparing with 0
        {
            result2 = true;
        }
        else
        {
            result2 = false;
        }
    }
    else
    {
        result2 = false;
    }

    while(1);
/* USER CODE END */

    return 0;
}


/* USER CODE BEGIN (4) */
/* USER CODE END */
